import { defineComponent as C, computed as b, inject as m, openBlock as c, createElementBlock as u, Fragment as I, unref as g, normalizeStyle as y, withModifiers as w, normalizeClass as B, createElementVNode as f, toDisplayString as O, renderSlot as p, renderList as T, createBlock as k, withCtx as v, pushScopeId as z, popScopeId as A, ref as H, provide as h, onMounted as q } from "vue";
const M = (o) => (z("data-v-ceb46d97"), o = o(), A(), o), G = /* @__PURE__ */ M(() => /* @__PURE__ */ f("g", { id: "caret-down" }, [
  /* @__PURE__ */ f("path", {
    id: "Vector",
    d: "M11.6646 4H2.33542C2.0556 4 1.89936 4.29436 2.07264 4.49531L6.73723 9.88431C6.87074 10.0386 7.12784 10.0386 7.26277 9.88431L11.9274 4.49531C12.1006 4.29436 11.9444 4 11.6646 4Z",
    fill: "#B8B8B8"
  })
], -1)), J = [
  G
], K = /* @__PURE__ */ M(() => /* @__PURE__ */ f("svg", {
  width: "14",
  height: "14",
  viewBox: "0 0 14 14",
  fill: "none",
  xmlns: "http://www.w3.org/2000/svg"
}, [
  /* @__PURE__ */ f("g", { id: "Folder" }, [
    /* @__PURE__ */ f("path", {
      id: "Vector",
      d: "M12.52 3.66055H7.135L5.3755 1.90742C5.35311 1.88559 5.32367 1.87332 5.293 1.87305H1.48C1.2145 1.87305 1 2.09648 1 2.37305V11.623C1 11.8996 1.2145 12.123 1.48 12.123H12.52C12.7855 12.123 13 11.8996 13 11.623V4.16055C13 3.88398 12.7855 3.66055 12.52 3.66055ZM11.92 10.998H2.08V2.99805H4.9075L6.7015 4.78555H11.92V10.998Z",
      fill: "#4A4A66"
    })
  ])
], -1)), P = { class: "name" }, Q = /* @__PURE__ */ C({
  __name: "FolderItem",
  props: {
    folder: {}
  },
  setup(o) {
    const l = o, e = b(() => ({
      paddingLeft: `${l.folder.level * (s || 20)}px`
    })), t = m("customize"), s = m("space"), d = m("toggleFolder");
    return (i, r) => (c(), u(I, null, [
      g(t) ? (c(), u("div", {
        key: 1,
        class: "folder-item yt-file-tree",
        style: y(e.value),
        onClick: r[1] || (r[1] = w((a) => g(d)(i.folder), ["stop"]))
      }, [
        p(i.$slots, "folder", { folder: i.folder }, void 0, !0)
      ], 4)) : (c(), u("div", {
        key: 0,
        class: "folder-item yt-file-tree",
        style: y(e.value),
        onClick: r[0] || (r[0] = w((a) => g(d)(i.folder), ["stop"]))
      }, [
        (c(), u("svg", {
          class: B([[i.folder.isOpen ? "open" : "close", i.folder.children.length > 0 ? "" : "hide"], "up-down menu-icon"]),
          width: "14",
          height: "14",
          viewBox: "0 0 14 14",
          fill: "none",
          xmlns: "http://www.w3.org/2000/svg"
        }, J, 2)),
        K,
        f("div", P, [
          f("span", null, O(i.folder.name), 1)
        ])
      ], 4)),
      (c(!0), u(I, null, T(i.folder.isOpen ? i.folder.children : [], (a, F) => (c(), k(L, {
        key: "TreeItem-" + F + "level-" + i.folder.level,
        item: a
      }, {
        folder: v(({ folder: n }) => [
          p(i.$slots, "folder", { folder: n }, void 0, !0)
        ]),
        file: v(({ file: n }) => [
          p(i.$slots, "file", { file: n }, void 0, !0)
        ]),
        _: 2
      }, 1032, ["item"]))), 128))
    ], 64));
  }
});
const S = (o, l) => {
  const e = o.__vccOpts || o;
  for (const [t, s] of l)
    e[t] = s;
  return e;
}, R = /* @__PURE__ */ S(Q, [["__scopeId", "data-v-ceb46d97"]]), U = (o) => (z("data-v-bcfb0700"), o = o(), A(), o), W = ["onClick"], X = /* @__PURE__ */ U(() => /* @__PURE__ */ f("svg", {
  width: "14",
  height: "14",
  class: "file-icon",
  viewBox: "0 0 14 14",
  fill: "none",
  xmlns: "http://www.w3.org/2000/svg"
}, [
  /* @__PURE__ */ f("g", { id: "iframe" }, [
    /* @__PURE__ */ f("path", {
      id: "Vector",
      d: "M12.52 1H1.48001C1.21451 1 1.00001 1.2145 1.00001 1.48V12.52C1.00001 12.7855 1.21451 13 1.48001 13H12.52C12.7855 13 13 12.7855 13 12.52V1.48C13 1.2145 12.7855 1 12.52 1ZM2.08001 2.08H4.12001V11.92H2.08001V2.08ZM11.92 11.92H5.08001V5.08H11.92V11.92ZM5.08001 4.12V2.08H11.92V4.12H5.08001Z",
      fill: "#4A4A66"
    })
  ])
], -1)), Y = { class: "name" }, x = ["onClick"], ee = /* @__PURE__ */ C({
  __name: "FileItem",
  props: {
    file: {}
  },
  setup(o) {
    const l = o, e = b(() => ({
      paddingLeft: `${l.file.level * (d || 20)}px`
    })), t = m("setActiveFile"), s = m("customize"), d = m("space"), i = () => {
      t(l.file.id);
    };
    return (r, a) => g(s) ? (c(), u("div", {
      key: 1,
      class: "file-item yt-file-tree",
      style: y(e.value),
      onClick: w(i, ["stop"])
    }, [
      p(r.$slots, "file", { file: r.file }, void 0, !0)
    ], 12, x)) : (c(), u("div", {
      key: 0,
      class: "file-item yt-file-tree",
      style: y(e.value),
      onClick: w(i, ["stop"])
    }, [
      X,
      f("div", Y, [
        f("span", null, O(r.file.name), 1)
      ])
    ], 12, W));
  }
});
const te = /* @__PURE__ */ S(ee, [["__scopeId", "data-v-bcfb0700"]]), L = /* @__PURE__ */ C({
  __name: "TreeItem",
  props: {
    item: {}
  },
  setup(o) {
    const l = m("activeFile");
    return (e, t) => e.item.isFolder ? (c(), k(R, {
      key: 0,
      folder: e.item
    }, {
      folder: v(({ folder: s }) => [
        p(e.$slots, "folder", { folder: s })
      ]),
      file: v(({ file: s }) => [
        p(e.$slots, "file", { file: s })
      ]),
      _: 3
    }, 8, ["folder"])) : (c(), k(te, {
      key: 1,
      file: e.item,
      class: B({ active: g(l).has(e.item.id) })
    }, {
      file: v(({ file: s }) => [
        p(e.$slots, "file", { file: s })
      ]),
      _: 3
    }, 8, ["file", "class"]));
  }
}), V = (o, l = !1, e = 0, t = 0) => {
  const s = [];
  for (const d of o) {
    const { id: i, name: r, isFolder: a } = d;
    a ? s.push(
      Object.assign(d, {
        id: i,
        name: r,
        isFolder: !!a,
        level: e,
        isOpen: l,
        parentId: t,
        children: V(d.children, l, e + 1, d.id)
      })
    ) : s.push(
      Object.assign(d, {
        id: i,
        level: e,
        name: r,
        parentId: t,
        isFolder: !!a
      })
    );
  }
  return s;
}, Z = (o, l, e) => {
  for (const t of o)
    if (t.id === e)
      for (const s of Object.keys(l))
        t[s] = l[s];
    else
      t.isFolder && Z(t.children, l, e);
}, j = (o, l) => {
  let e;
  for (const t of o)
    if (t.id === l) {
      e = t;
      break;
    } else
      t.isFolder && !e && (e = j(t.children, l));
  return e;
}, D = (o, l) => {
  for (const e of o) {
    if (e.id === l && !e.isFolder)
      return !0;
    if (e.isFolder) {
      const t = e;
      if (D(t.children, l))
        return t.isOpen = !0, !0;
    }
  }
  return !1;
}, oe = /* @__PURE__ */ C({
  __name: "Tree",
  props: {
    treeData: {},
    defaultFile: {},
    expandAll: { type: Boolean },
    customize: { type: Boolean },
    space: {}
  },
  emits: ["change"],
  setup(o, { expose: l, emit: e }) {
    const t = o, s = H([]), d = H(/* @__PURE__ */ new Set([])), i = (n) => {
      a(n.id, { isOpen: !n.isOpen });
    }, r = (n) => {
      const _ = j(s.value, n);
      _ ? (d.value = /* @__PURE__ */ new Set([n]), e("change", _), F(n)) : console.error("This id is not a file");
    };
    h("setActiveFile", r), h("activeFile", d), h("toggleFolder", i), h("space", t.space), h("customize", t.customize), q(() => {
      t.expandAll ? s.value = V(t.treeData, !0) : s.value = V(t.treeData), t.defaultFile && r(t.defaultFile);
    });
    const a = (n, _) => {
      Z(s.value, _, n);
    }, F = (n) => {
      D(s.value, n);
    };
    return l({
      update: a,
      expand: F,
      setActiveFile: r
    }), (n, _) => (c(!0), u(I, null, T(s.value, (E, N) => (c(), k(L, {
      key: "TreeItem-" + N,
      item: E
    }, {
      folder: v(({ folder: $ }) => [
        p(n.$slots, "folder", { folder: $ })
      ]),
      file: v(({ file: $ }) => [
        p(n.$slots, "file", { file: $ })
      ]),
      _: 2
    }, 1032, ["item"]))), 128));
  }
}), le = {
  install: (o) => {
    o.component("Tree", oe);
  }
};
export {
  oe as Tree,
  le as default
};
